Update a Contact
curl --request PUT \
--url https://api.virtuoussoftware.com/api/Contact/{contactId} \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"contactType": "<string>",
"name": "<string>",
"informalName": "<string>",
"description": "<string>",
"website": "<string>",
"maritalStatus": "<string>",
"anniversaryMonth": "<integer>",
"anniversaryDay": "<integer>",
"anniversaryYear": "<integer>",
"originSegmentId": "<integer>",
"isPrivate": "<boolean>",
"customFields": [
{
"name": "<string>",
"value": "<string>",
"displayName": "<string>"
},
{
"name": "<string>",
"value": "<string>",
"displayName": "<string>"
}
],
"customCollections": [
{
"name": "<string>",
"fields": [
{
"name": "<string>",
"value": "<string>"
},
{
"name": "<string>",
"value": "<string>"
}
]
},
{
"name": "<string>",
"fields": [
{
"name": "<string>",
"value": "<string>"
},
{
"name": "<string>",
"value": "<string>"
}
]
}
]
}
'const options = {
method: 'PUT',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
contactType: '<string>',
name: '<string>',
informalName: '<string>',
description: '<string>',
website: '<string>',
maritalStatus: '<string>',
anniversaryMonth: '<integer>',
anniversaryDay: '<integer>',
anniversaryYear: '<integer>',
originSegmentId: '<integer>',
isPrivate: '<boolean>',
customFields: [
{name: '<string>', value: '<string>', displayName: '<string>'},
{name: '<string>', value: '<string>', displayName: '<string>'}
],
customCollections: [
{
name: '<string>',
fields: [{name: '<string>', value: '<string>'}, {name: '<string>', value: '<string>'}]
},
{
name: '<string>',
fields: [{name: '<string>', value: '<string>'}, {name: '<string>', value: '<string>'}]
}
]
})
};
fetch('https://api.virtuoussoftware.com/api/Contact/{contactId}', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));import requests
url = "https://api.virtuoussoftware.com/api/Contact/{contactId}"
payload = {
"contactType": "<string>",
"name": "<string>",
"informalName": "<string>",
"description": "<string>",
"website": "<string>",
"maritalStatus": "<string>",
"anniversaryMonth": "<integer>",
"anniversaryDay": "<integer>",
"anniversaryYear": "<integer>",
"originSegmentId": "<integer>",
"isPrivate": "<boolean>",
"customFields": [
{
"name": "<string>",
"value": "<string>",
"displayName": "<string>"
},
{
"name": "<string>",
"value": "<string>",
"displayName": "<string>"
}
],
"customCollections": [
{
"name": "<string>",
"fields": [
{
"name": "<string>",
"value": "<string>"
},
{
"name": "<string>",
"value": "<string>"
}
]
},
{
"name": "<string>",
"fields": [
{
"name": "<string>",
"value": "<string>"
},
{
"name": "<string>",
"value": "<string>"
}
]
}
]
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.put(url, json=payload, headers=headers)
print(response.text)using RestSharp;
var options = new RestClientOptions("https://api.virtuoussoftware.com/api/Contact/{contactId}");
var client = new RestClient(options);
var request = new RestRequest("");
request.AddHeader("Authorization", "Bearer <token>");
request.AddJsonBody("{\n \"contactType\": \"<string>\",\n \"name\": \"<string>\",\n \"informalName\": \"<string>\",\n \"description\": \"<string>\",\n \"website\": \"<string>\",\n \"maritalStatus\": \"<string>\",\n \"anniversaryMonth\": \"<integer>\",\n \"anniversaryDay\": \"<integer>\",\n \"anniversaryYear\": \"<integer>\",\n \"originSegmentId\": \"<integer>\",\n \"isPrivate\": \"<boolean>\",\n \"customFields\": [\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\",\n \"displayName\": \"<string>\"\n },\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\",\n \"displayName\": \"<string>\"\n }\n ],\n \"customCollections\": [\n {\n \"name\": \"<string>\",\n \"fields\": [\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\"\n },\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\"\n }\n ]\n },\n {\n \"name\": \"<string>\",\n \"fields\": [\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\"\n },\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\"\n }\n ]\n }\n ]\n}", false);
var response = await client.PutAsync(request);
Console.WriteLine("{0}", response.Content);
<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.virtuoussoftware.com/api/Contact/{contactId}",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "PUT",
CURLOPT_POSTFIELDS => json_encode([
'contactType' => '<string>',
'name' => '<string>',
'informalName' => '<string>',
'description' => '<string>',
'website' => '<string>',
'maritalStatus' => '<string>',
'anniversaryMonth' => '<integer>',
'anniversaryDay' => '<integer>',
'anniversaryYear' => '<integer>',
'originSegmentId' => '<integer>',
'isPrivate' => '<boolean>',
'customFields' => [
[
'name' => '<string>',
'value' => '<string>',
'displayName' => '<string>'
],
[
'name' => '<string>',
'value' => '<string>',
'displayName' => '<string>'
]
],
'customCollections' => [
[
'name' => '<string>',
'fields' => [
[
'name' => '<string>',
'value' => '<string>'
],
[
'name' => '<string>',
'value' => '<string>'
]
]
],
[
'name' => '<string>',
'fields' => [
[
'name' => '<string>',
'value' => '<string>'
],
[
'name' => '<string>',
'value' => '<string>'
]
]
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}HttpResponse<String> response = Unirest.put("https://api.virtuoussoftware.com/api/Contact/{contactId}")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"contactType\": \"<string>\",\n \"name\": \"<string>\",\n \"informalName\": \"<string>\",\n \"description\": \"<string>\",\n \"website\": \"<string>\",\n \"maritalStatus\": \"<string>\",\n \"anniversaryMonth\": \"<integer>\",\n \"anniversaryDay\": \"<integer>\",\n \"anniversaryYear\": \"<integer>\",\n \"originSegmentId\": \"<integer>\",\n \"isPrivate\": \"<boolean>\",\n \"customFields\": [\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\",\n \"displayName\": \"<string>\"\n },\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\",\n \"displayName\": \"<string>\"\n }\n ],\n \"customCollections\": [\n {\n \"name\": \"<string>\",\n \"fields\": [\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\"\n },\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\"\n }\n ]\n },\n {\n \"name\": \"<string>\",\n \"fields\": [\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\"\n },\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\"\n }\n ]\n }\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.virtuoussoftware.com/api/Contact/{contactId}")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"contactType\": \"<string>\",\n \"name\": \"<string>\",\n \"informalName\": \"<string>\",\n \"description\": \"<string>\",\n \"website\": \"<string>\",\n \"maritalStatus\": \"<string>\",\n \"anniversaryMonth\": \"<integer>\",\n \"anniversaryDay\": \"<integer>\",\n \"anniversaryYear\": \"<integer>\",\n \"originSegmentId\": \"<integer>\",\n \"isPrivate\": \"<boolean>\",\n \"customFields\": [\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\",\n \"displayName\": \"<string>\"\n },\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\",\n \"displayName\": \"<string>\"\n }\n ],\n \"customCollections\": [\n {\n \"name\": \"<string>\",\n \"fields\": [\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\"\n },\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\"\n }\n ]\n },\n {\n \"name\": \"<string>\",\n \"fields\": [\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\"\n },\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\"\n }\n ]\n }\n ]\n}"
response = http.request(request)
puts response.read_bodyconst url = 'https://api.virtuoussoftware.com/api/Contact/{contactId}';
const options = {
method: 'PUT',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
contactType: '<string>',
name: '<string>',
informalName: '<string>',
description: '<string>',
website: '<string>',
maritalStatus: '<string>',
anniversaryMonth: '<integer>',
anniversaryDay: '<integer>',
anniversaryYear: '<integer>',
originSegmentId: '<integer>',
isPrivate: '<boolean>',
customFields: [
{name: '<string>', value: '<string>', displayName: '<string>'},
{name: '<string>', value: '<string>', displayName: '<string>'}
],
customCollections: [
{
name: '<string>',
fields: [{name: '<string>', value: '<string>'}, {name: '<string>', value: '<string>'}]
},
{
name: '<string>',
fields: [{name: '<string>', value: '<string>'}, {name: '<string>', value: '<string>'}]
}
]
})
};
fetch(url, options)
.then(res => res.json())
.then(json => console.log(json))
.catch(err => console.error(err));{
"isCurrentUserFollowing": true,
"id": 100234,
"contactType": "Household",
"isPrivate": false,
"name": "Marcus Castellano",
"informalName": "Marcus & Elena Castellano",
"description": "Household led by Marcus Castellano; board member and major donor.",
"website": null,
"maritalStatus": "Married",
"anniversaryMonth": null,
"anniversaryDay": null,
"anniversaryYear": null,
"mergedIntoContactId": null,
"address": {
"id": 400123,
"label": "Home",
"address1": "219 Oak Hill Drive",
"address2": null,
"city": "Springfield",
"state": "OR",
"postal": "97478",
"country": "United States",
"isPrimary": true,
"canBePrimary": true,
"startMonth": null,
"startDay": null,
"endMonth": null,
"endDay": null
},
"giftAskAmount": "1000.00",
"giftAskType": "Capital Campaign",
"lifeToDateGiving": "42500.00",
"yearToDateGiving": "4000.00",
"lastGiftAmount": "1000.00",
"lastGiftDate": "2025-10-12T00:00:00Z",
"contactIndividuals": [
{
"id": 200234,
"contactId": 100234,
"prefix": "Mr.",
"firstName": "Marcus",
"middleName": "David",
"lastName": "Castellano",
"suffix": null,
"gender": "Male",
"isPrimary": true,
"canBePrimary": true,
"isSecondary": false,
"canBeSecondary": true,
"birthMonth": 3,
"birthDay": 18,
"birthYear": 1972,
"birthDate": "1972-03-18T00:00:00Z",
"approximateAge": 53,
"isDeceased": false,
"passion": "Youth education",
"avatarUrl": "https://api.virtuoussoftware.com/api/ContactIndividual/200234/Avatar",
"contactMethods": [
{
"id": 300101,
"type": "Home Email",
"value": "marcus.castellano@example.org",
"isOptedIn": true,
"isPrimary": true,
"canBePrimary": true,
"isArchived": false
},
{
"id": 300102,
"type": "Mobile Phone",
"value": "(555) 012-3401",
"isOptedIn": true,
"isPrimary": true,
"canBePrimary": true,
"isArchived": false
},
{
"id": 300103,
"type": "Home Phone",
"value": "(555) 012-3400",
"isOptedIn": true,
"isPrimary": false,
"canBePrimary": true,
"isArchived": false
}
],
"createDateTimeUtc": "2018-09-15T14:22:31Z",
"modifiedDateTimeUtc": "2025-11-15T18:00:00Z",
"customFields": [
{
"name": "EngagementScore",
"value": "85",
"displayName": "Engagement Score"
},
{
"name": "CommunicationPreference",
"value": "Email",
"displayName": "Communication Preference"
}
],
"customCollections": []
},
{
"id": 200235,
"contactId": 100234,
"prefix": "Mrs.",
"firstName": "Elena",
"middleName": "Maria",
"lastName": "Castellano",
"suffix": null,
"gender": "Female",
"isPrimary": false,
"canBePrimary": true,
"isSecondary": true,
"canBeSecondary": true,
"birthMonth": 8,
"birthDay": 22,
"birthYear": 1974,
"birthDate": "1974-08-22T00:00:00Z",
"approximateAge": 51,
"isDeceased": false,
"passion": "Community health",
"avatarUrl": "https://api.virtuoussoftware.com/api/ContactIndividual/200235/Avatar",
"contactMethods": [
{
"id": 300104,
"type": "Home Email",
"value": "elena.castellano@example.org",
"isOptedIn": true,
"isPrimary": true,
"canBePrimary": true,
"isArchived": false
},
{
"id": 300105,
"type": "Mobile Phone",
"value": "(555) 012-3402",
"isOptedIn": true,
"isPrimary": true,
"canBePrimary": true,
"isArchived": false
}
],
"createDateTimeUtc": "2018-09-15T14:22:31Z",
"modifiedDateTimeUtc": "2025-11-15T18:00:00Z",
"customFields": [],
"customCollections": []
}
],
"contactGiftsUrl": "https://api.virtuoussoftware.com/api/Gift/ByContact/100234",
"contactPassthroughGiftsUrl": "https://api.virtuoussoftware.com/api/Gift/Passthrough/ByContact/100234",
"contactPlannedGiftsUrl": "https://api.virtuoussoftware.com/api/PlannedGift/ByContact/100234",
"contactRecurringGiftsUrl": "https://api.virtuoussoftware.com/api/RecurringGift/ByContact/100234",
"contactImportantNotesUrl": "https://api.virtuoussoftware.com/api/ContactNote/Important/ByContact/100234",
"contactNotesUrl": "https://api.virtuoussoftware.com/api/ContactNote/ByContact/100234",
"contactTagsUrl": "https://api.virtuoussoftware.com/api/ContactTag/ByContact/100234",
"contactRelationshipsUrl": "https://api.virtuoussoftware.com/api/Relationship/ByContact/100234",
"primaryAvatarUrl": "https://api.virtuoussoftware.com/api/ContactIndividual/200234/Avatar",
"contactReferences": [
{
"source": "Raise",
"id": "200234"
}
],
"originSegmentId": 2010,
"originSegment": "Spring Appeal 2025",
"createDateTimeUtc": "2018-09-15T14:22:31Z",
"createdByUser": "Data Import",
"modifiedDateTimeUtc": "2025-11-15T18:00:00Z",
"modifiedByUser": "Partner Integration",
"tags": [
"Board Member",
"Major Donor"
],
"organizationGroups": [
"Board of Directors"
],
"customFields": [
{
"name": "EngagementScore",
"value": "85",
"displayName": "Engagement Score"
},
{
"name": "CommunicationPreference",
"value": "Email",
"displayName": "Communication Preference"
}
],
"customCollections": []
}{
"message": "Authorization has been denied for this request."
}{
"message": "You do not have permission to perform this action."
}{
"message": "Rate limit exceeded. Try again later."
}How to Create and Update Contacts
Update a Contact
Similar to other update methods in the API, excluding a property will remove it’s value from the object. If you’re only updating a single property, the entire model is still required.
PUT
/
api
/
Contact
/
{contactId}
Update a Contact
curl --request PUT \
--url https://api.virtuoussoftware.com/api/Contact/{contactId} \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"contactType": "<string>",
"name": "<string>",
"informalName": "<string>",
"description": "<string>",
"website": "<string>",
"maritalStatus": "<string>",
"anniversaryMonth": "<integer>",
"anniversaryDay": "<integer>",
"anniversaryYear": "<integer>",
"originSegmentId": "<integer>",
"isPrivate": "<boolean>",
"customFields": [
{
"name": "<string>",
"value": "<string>",
"displayName": "<string>"
},
{
"name": "<string>",
"value": "<string>",
"displayName": "<string>"
}
],
"customCollections": [
{
"name": "<string>",
"fields": [
{
"name": "<string>",
"value": "<string>"
},
{
"name": "<string>",
"value": "<string>"
}
]
},
{
"name": "<string>",
"fields": [
{
"name": "<string>",
"value": "<string>"
},
{
"name": "<string>",
"value": "<string>"
}
]
}
]
}
'const options = {
method: 'PUT',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
contactType: '<string>',
name: '<string>',
informalName: '<string>',
description: '<string>',
website: '<string>',
maritalStatus: '<string>',
anniversaryMonth: '<integer>',
anniversaryDay: '<integer>',
anniversaryYear: '<integer>',
originSegmentId: '<integer>',
isPrivate: '<boolean>',
customFields: [
{name: '<string>', value: '<string>', displayName: '<string>'},
{name: '<string>', value: '<string>', displayName: '<string>'}
],
customCollections: [
{
name: '<string>',
fields: [{name: '<string>', value: '<string>'}, {name: '<string>', value: '<string>'}]
},
{
name: '<string>',
fields: [{name: '<string>', value: '<string>'}, {name: '<string>', value: '<string>'}]
}
]
})
};
fetch('https://api.virtuoussoftware.com/api/Contact/{contactId}', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));import requests
url = "https://api.virtuoussoftware.com/api/Contact/{contactId}"
payload = {
"contactType": "<string>",
"name": "<string>",
"informalName": "<string>",
"description": "<string>",
"website": "<string>",
"maritalStatus": "<string>",
"anniversaryMonth": "<integer>",
"anniversaryDay": "<integer>",
"anniversaryYear": "<integer>",
"originSegmentId": "<integer>",
"isPrivate": "<boolean>",
"customFields": [
{
"name": "<string>",
"value": "<string>",
"displayName": "<string>"
},
{
"name": "<string>",
"value": "<string>",
"displayName": "<string>"
}
],
"customCollections": [
{
"name": "<string>",
"fields": [
{
"name": "<string>",
"value": "<string>"
},
{
"name": "<string>",
"value": "<string>"
}
]
},
{
"name": "<string>",
"fields": [
{
"name": "<string>",
"value": "<string>"
},
{
"name": "<string>",
"value": "<string>"
}
]
}
]
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.put(url, json=payload, headers=headers)
print(response.text)using RestSharp;
var options = new RestClientOptions("https://api.virtuoussoftware.com/api/Contact/{contactId}");
var client = new RestClient(options);
var request = new RestRequest("");
request.AddHeader("Authorization", "Bearer <token>");
request.AddJsonBody("{\n \"contactType\": \"<string>\",\n \"name\": \"<string>\",\n \"informalName\": \"<string>\",\n \"description\": \"<string>\",\n \"website\": \"<string>\",\n \"maritalStatus\": \"<string>\",\n \"anniversaryMonth\": \"<integer>\",\n \"anniversaryDay\": \"<integer>\",\n \"anniversaryYear\": \"<integer>\",\n \"originSegmentId\": \"<integer>\",\n \"isPrivate\": \"<boolean>\",\n \"customFields\": [\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\",\n \"displayName\": \"<string>\"\n },\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\",\n \"displayName\": \"<string>\"\n }\n ],\n \"customCollections\": [\n {\n \"name\": \"<string>\",\n \"fields\": [\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\"\n },\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\"\n }\n ]\n },\n {\n \"name\": \"<string>\",\n \"fields\": [\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\"\n },\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\"\n }\n ]\n }\n ]\n}", false);
var response = await client.PutAsync(request);
Console.WriteLine("{0}", response.Content);
<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.virtuoussoftware.com/api/Contact/{contactId}",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "PUT",
CURLOPT_POSTFIELDS => json_encode([
'contactType' => '<string>',
'name' => '<string>',
'informalName' => '<string>',
'description' => '<string>',
'website' => '<string>',
'maritalStatus' => '<string>',
'anniversaryMonth' => '<integer>',
'anniversaryDay' => '<integer>',
'anniversaryYear' => '<integer>',
'originSegmentId' => '<integer>',
'isPrivate' => '<boolean>',
'customFields' => [
[
'name' => '<string>',
'value' => '<string>',
'displayName' => '<string>'
],
[
'name' => '<string>',
'value' => '<string>',
'displayName' => '<string>'
]
],
'customCollections' => [
[
'name' => '<string>',
'fields' => [
[
'name' => '<string>',
'value' => '<string>'
],
[
'name' => '<string>',
'value' => '<string>'
]
]
],
[
'name' => '<string>',
'fields' => [
[
'name' => '<string>',
'value' => '<string>'
],
[
'name' => '<string>',
'value' => '<string>'
]
]
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}HttpResponse<String> response = Unirest.put("https://api.virtuoussoftware.com/api/Contact/{contactId}")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"contactType\": \"<string>\",\n \"name\": \"<string>\",\n \"informalName\": \"<string>\",\n \"description\": \"<string>\",\n \"website\": \"<string>\",\n \"maritalStatus\": \"<string>\",\n \"anniversaryMonth\": \"<integer>\",\n \"anniversaryDay\": \"<integer>\",\n \"anniversaryYear\": \"<integer>\",\n \"originSegmentId\": \"<integer>\",\n \"isPrivate\": \"<boolean>\",\n \"customFields\": [\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\",\n \"displayName\": \"<string>\"\n },\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\",\n \"displayName\": \"<string>\"\n }\n ],\n \"customCollections\": [\n {\n \"name\": \"<string>\",\n \"fields\": [\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\"\n },\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\"\n }\n ]\n },\n {\n \"name\": \"<string>\",\n \"fields\": [\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\"\n },\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\"\n }\n ]\n }\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.virtuoussoftware.com/api/Contact/{contactId}")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"contactType\": \"<string>\",\n \"name\": \"<string>\",\n \"informalName\": \"<string>\",\n \"description\": \"<string>\",\n \"website\": \"<string>\",\n \"maritalStatus\": \"<string>\",\n \"anniversaryMonth\": \"<integer>\",\n \"anniversaryDay\": \"<integer>\",\n \"anniversaryYear\": \"<integer>\",\n \"originSegmentId\": \"<integer>\",\n \"isPrivate\": \"<boolean>\",\n \"customFields\": [\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\",\n \"displayName\": \"<string>\"\n },\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\",\n \"displayName\": \"<string>\"\n }\n ],\n \"customCollections\": [\n {\n \"name\": \"<string>\",\n \"fields\": [\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\"\n },\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\"\n }\n ]\n },\n {\n \"name\": \"<string>\",\n \"fields\": [\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\"\n },\n {\n \"name\": \"<string>\",\n \"value\": \"<string>\"\n }\n ]\n }\n ]\n}"
response = http.request(request)
puts response.read_bodyconst url = 'https://api.virtuoussoftware.com/api/Contact/{contactId}';
const options = {
method: 'PUT',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
contactType: '<string>',
name: '<string>',
informalName: '<string>',
description: '<string>',
website: '<string>',
maritalStatus: '<string>',
anniversaryMonth: '<integer>',
anniversaryDay: '<integer>',
anniversaryYear: '<integer>',
originSegmentId: '<integer>',
isPrivate: '<boolean>',
customFields: [
{name: '<string>', value: '<string>', displayName: '<string>'},
{name: '<string>', value: '<string>', displayName: '<string>'}
],
customCollections: [
{
name: '<string>',
fields: [{name: '<string>', value: '<string>'}, {name: '<string>', value: '<string>'}]
},
{
name: '<string>',
fields: [{name: '<string>', value: '<string>'}, {name: '<string>', value: '<string>'}]
}
]
})
};
fetch(url, options)
.then(res => res.json())
.then(json => console.log(json))
.catch(err => console.error(err));{
"isCurrentUserFollowing": true,
"id": 100234,
"contactType": "Household",
"isPrivate": false,
"name": "Marcus Castellano",
"informalName": "Marcus & Elena Castellano",
"description": "Household led by Marcus Castellano; board member and major donor.",
"website": null,
"maritalStatus": "Married",
"anniversaryMonth": null,
"anniversaryDay": null,
"anniversaryYear": null,
"mergedIntoContactId": null,
"address": {
"id": 400123,
"label": "Home",
"address1": "219 Oak Hill Drive",
"address2": null,
"city": "Springfield",
"state": "OR",
"postal": "97478",
"country": "United States",
"isPrimary": true,
"canBePrimary": true,
"startMonth": null,
"startDay": null,
"endMonth": null,
"endDay": null
},
"giftAskAmount": "1000.00",
"giftAskType": "Capital Campaign",
"lifeToDateGiving": "42500.00",
"yearToDateGiving": "4000.00",
"lastGiftAmount": "1000.00",
"lastGiftDate": "2025-10-12T00:00:00Z",
"contactIndividuals": [
{
"id": 200234,
"contactId": 100234,
"prefix": "Mr.",
"firstName": "Marcus",
"middleName": "David",
"lastName": "Castellano",
"suffix": null,
"gender": "Male",
"isPrimary": true,
"canBePrimary": true,
"isSecondary": false,
"canBeSecondary": true,
"birthMonth": 3,
"birthDay": 18,
"birthYear": 1972,
"birthDate": "1972-03-18T00:00:00Z",
"approximateAge": 53,
"isDeceased": false,
"passion": "Youth education",
"avatarUrl": "https://api.virtuoussoftware.com/api/ContactIndividual/200234/Avatar",
"contactMethods": [
{
"id": 300101,
"type": "Home Email",
"value": "marcus.castellano@example.org",
"isOptedIn": true,
"isPrimary": true,
"canBePrimary": true,
"isArchived": false
},
{
"id": 300102,
"type": "Mobile Phone",
"value": "(555) 012-3401",
"isOptedIn": true,
"isPrimary": true,
"canBePrimary": true,
"isArchived": false
},
{
"id": 300103,
"type": "Home Phone",
"value": "(555) 012-3400",
"isOptedIn": true,
"isPrimary": false,
"canBePrimary": true,
"isArchived": false
}
],
"createDateTimeUtc": "2018-09-15T14:22:31Z",
"modifiedDateTimeUtc": "2025-11-15T18:00:00Z",
"customFields": [
{
"name": "EngagementScore",
"value": "85",
"displayName": "Engagement Score"
},
{
"name": "CommunicationPreference",
"value": "Email",
"displayName": "Communication Preference"
}
],
"customCollections": []
},
{
"id": 200235,
"contactId": 100234,
"prefix": "Mrs.",
"firstName": "Elena",
"middleName": "Maria",
"lastName": "Castellano",
"suffix": null,
"gender": "Female",
"isPrimary": false,
"canBePrimary": true,
"isSecondary": true,
"canBeSecondary": true,
"birthMonth": 8,
"birthDay": 22,
"birthYear": 1974,
"birthDate": "1974-08-22T00:00:00Z",
"approximateAge": 51,
"isDeceased": false,
"passion": "Community health",
"avatarUrl": "https://api.virtuoussoftware.com/api/ContactIndividual/200235/Avatar",
"contactMethods": [
{
"id": 300104,
"type": "Home Email",
"value": "elena.castellano@example.org",
"isOptedIn": true,
"isPrimary": true,
"canBePrimary": true,
"isArchived": false
},
{
"id": 300105,
"type": "Mobile Phone",
"value": "(555) 012-3402",
"isOptedIn": true,
"isPrimary": true,
"canBePrimary": true,
"isArchived": false
}
],
"createDateTimeUtc": "2018-09-15T14:22:31Z",
"modifiedDateTimeUtc": "2025-11-15T18:00:00Z",
"customFields": [],
"customCollections": []
}
],
"contactGiftsUrl": "https://api.virtuoussoftware.com/api/Gift/ByContact/100234",
"contactPassthroughGiftsUrl": "https://api.virtuoussoftware.com/api/Gift/Passthrough/ByContact/100234",
"contactPlannedGiftsUrl": "https://api.virtuoussoftware.com/api/PlannedGift/ByContact/100234",
"contactRecurringGiftsUrl": "https://api.virtuoussoftware.com/api/RecurringGift/ByContact/100234",
"contactImportantNotesUrl": "https://api.virtuoussoftware.com/api/ContactNote/Important/ByContact/100234",
"contactNotesUrl": "https://api.virtuoussoftware.com/api/ContactNote/ByContact/100234",
"contactTagsUrl": "https://api.virtuoussoftware.com/api/ContactTag/ByContact/100234",
"contactRelationshipsUrl": "https://api.virtuoussoftware.com/api/Relationship/ByContact/100234",
"primaryAvatarUrl": "https://api.virtuoussoftware.com/api/ContactIndividual/200234/Avatar",
"contactReferences": [
{
"source": "Raise",
"id": "200234"
}
],
"originSegmentId": 2010,
"originSegment": "Spring Appeal 2025",
"createDateTimeUtc": "2018-09-15T14:22:31Z",
"createdByUser": "Data Import",
"modifiedDateTimeUtc": "2025-11-15T18:00:00Z",
"modifiedByUser": "Partner Integration",
"tags": [
"Board Member",
"Major Donor"
],
"organizationGroups": [
"Board of Directors"
],
"customFields": [
{
"name": "EngagementScore",
"value": "85",
"displayName": "Engagement Score"
},
{
"name": "CommunicationPreference",
"value": "Email",
"displayName": "Communication Preference"
}
],
"customCollections": []
}{
"message": "Authorization has been denied for this request."
}{
"message": "You do not have permission to perform this action."
}{
"message": "Rate limit exceeded. Try again later."
}Authorizations
Body
application/json
Response
OK
Last modified on April 23, 2026
Was this page helpful?